<template>
  <v-card>
    <v-tabs>
      <v-tab>{{ $t('label.summary') }}</v-tab>
      <v-tab-item
        v-for="tabs in 2"
        :key="tabs"
      >
        <v-container fluid>
          <div v-if="tabs === 1">
            <v-row>
              <v-card>
                <v-card-text
                  v-if="detailSurvey"
                  class="headline-detail"
                >
                  {{ detailSurvey.survey_name }}
                </v-card-text>
              </v-card>
              <v-expansion-panels
                multiple
                flat
              >
                <v-expansion-panel>
                  <v-expansion-panel-header style="font-size: 20px">
                    {{ $t('label.preview') }}
                  </v-expansion-panel-header>
                  <v-expansion-panel-content>
                    <v-card
                      :disabled="disabled"
                      class="detail-survey"
                    >
                      <v-card-title>
                        {{ $t('label.purpose_survey') }}
                      </v-card-title>
                      <v-card-text v-if="detailSurvey">
                        <html-binding-text :html="detailSurvey.description" />
                      </v-card-text>
                    </v-card>
                    <v-card
                      :disabled="disabled"
                      class="detail-survey"
                    >
                      <v-card-title>
                        {{ $t('label.introduction_survey') }}
                      </v-card-title>
                      <v-card-text v-if="detailSurvey">
                        <html-binding-text :html="detailSurvey.introduction" />
                      </v-card-text>
                    </v-card>
                  </v-expansion-panel-content>
                </v-expansion-panel>
              </v-expansion-panels>
            </v-row>
            <v-spacer />
            <v-row>
              <v-card>
                <v-card-text class="headline">{{ $t('label.survey_responses') }}</v-card-text>
              </v-card>
            </v-row>
            <v-row>
              <v-col auto>
                <v-simple-table fixed-header height="300px">
                  <template v-slot:default>
                    <thead>
                      <tr v-if="listDataHeader">
                        <th
                          v-for="(body, index) in listDataHeader"
                          :key="index"
                        >
                          {{ body.question }}
                        </th>
                      </tr>
                    </thead>
                    <tbody>
                      <tr v-for="(item, index) in listData" :key="index">
                        <td
                          v-for="(body, index) in item"
                          v-if="item[index]"
                          :key="index"
                        >
                          <div >
                            {{ parseDataString(body) }}
                          </div>
                        </td>
                      </tr>
                    </tbody>
                  </template>
                </v-simple-table>
                <pagination
                  :total="total"
                  :page="listQuery.page"
                  :limit="listQuery.limit"
                  :on-next="nextPage"
                />
              </v-col>
            </v-row>
          </div>
          <div v-else>
            <v-row>
              <h2>Tab 2</h2>
            </v-row>
          </div>
        </v-container>
      </v-tab-item>
    </v-tabs>
  </v-card>
</template>

<script>
import { mapGetters } from 'vuex'
export default {
  name: 'ResultsSurvey',
  data() {
    return {
      disabled: true,
      listDataHeader: [],
      listData: null,
      total: 0,
      listQuery: {
        page: 1,
        limit: 10,
        search: ''
      }
    }
  },
  computed: {
    ...mapGetters('survey', [
      'detailSurvey',
      'listResponseSurvey'
    ])
  },
  async mounted() {
    if (this.detailSurvey === null) {
      this.$router.push('/survey/index')
    }
    const params = { id_survey: this.detailSurvey.id, ...this.listQuery }
    const response = await this.$store.dispatch('survey/getResponseSurvey', params)
    this.listData = response.data.answers
    this.listDataHeader = this.listData[0]
    this.total = response.data._meta.totalPages
  },
  methods: {
    parseDataString(data) {
      switch (data.form_type) {
        // eslint-disable-next-line no-case-declarations
        case 'SHORTTEXT':
          let answer = ''
          if (data.answer.length > 0) {
            answer = data.answer
          }
          return answer
        // eslint-disable-next-line no-case-declarations
        case 'CHECKBOX':
          const arr = []
          data.answer.forEach(function(element) {
            if (element.body) {
              arr.push(element.body)
            }
          })
          const results = arr.join(', ')
          return results
        case 'MULTI_CHOICE':
          return data.answer.body
        // eslint-disable-next-line no-case-declarations
        case 'ADDRESS':
          let alamat = ''
          if (data.answer[0]) {
            alamat = `${data.answer[0].kota_nama}, ${data.answer[0].kecamatan_nama}, ${data.answer[0].desa_nama}`
          }
          return alamat
        default:
          return data.answer
      }
    },
    async nextPage(value) {
      this.listQuery.page = value
      const params = { id_survey: this.detailSurvey.id, ...this.listQuery }
      const response = await this.$store.dispatch('survey/getResponseSurvey', params)
      this.listData = response.data.answers
    }
  }
}
</script>
<style scoped>
  .detail-survey {
    margin-bottom: 12px;
    background: #F2F2F2;
    box-shadow: 0px 1px 0px rgba(0, 0, 0, 0.25);
    border-radius: 8px 8px 0px 0px;
  }
</style>
